image:
  name: registry.gitlab.com/gitlab-org/terraform-images/stable:latest

variables:
  TF_ROOT: ${CI_PROJECT_DIR}/terraform  # The relative path to the root directory of the Terraform project
  TF_STATE_NAME: ${CI_COMMIT_BRANCH} # The name of the state file used by the GitLab Managed Terraform state backend
#  TF_STATE_NAME: default

cache:
  key: "${TF_ROOT}"
  paths:
    - ${TF_ROOT}/.terraform/

stages:
  - PREPARE
  - BUILD
  - DEPLOY
  - DESTROY

validate:
  stage: PREPARE
  rules: 
    - changes: 
      - ${TF_ROOT}/*.tf
  script:
    - gitlab-terraform init
    - gitlab-terraform validate

plan:
  stage: BUILD
  rules: 
    - changes: 
      - ${TF_ROOT}/*.tf
  before_script:
  - cd ${TF_ROOT}
  script:
    - gitlab-terraform plan
    - gitlab-terraform plan-json
  resource_group: ${TF_STATE_NAME}
  dependencies:
    - validate
  artifacts:
    name: plan
    paths:
      - ${TF_ROOT}/plan.cache
    reports:
      terraform: ${TF_ROOT}/plan.json

apply:
  stage: DEPLOY
  rules: 
    - changes: 
      - ${TF_ROOT}/*.tf
  before_script:
  - cd ${TF_ROOT}
  script:
    - gitlab-terraform apply
  resource_group: ${TF_STATE_NAME}
  dependencies:
    - plan
  when: manual
  
destroy:
  stage: DESTROY
  rules: 
    - changes: 
      - ${TF_ROOT}/*.tf
  before_script:
  - cd ${TF_ROOT}
  script:
    - gitlab-terraform destroy
  resource_group: ${TF_STATE_NAME}
  dependencies:
    - apply
  when: manual 
